#include    "ksysdefs.h"
#include    "ksysvtyp.h"
/**/
#include    "keddefs.h"
#include	"kedvars.h"
#include	"ksysprot.h"
#include	"kedfuncs.h"
/**/
/*EXTERN*/
/*GLOBAL*/
char    				*cpsx;
/**/
pcmd0(is)
char    *is;
{
/**/
	cdx.del = NO;
/**/
	while(isspace(*is)) ++is;
/**/
	cpsx = is;
/**/
	cdx.con = YES;
	cdx.act = NO;
/**/
	if(is[0] == ZERO)	cdx.cur = nextcd(cdx.cur);
/**/
	cdx.nn1 = cdx.nn2 = pcmd1(cpsx, cdx.cur);
/**/
	if(cpsx > is) 		cdx.act += 1;
/**/
	while(cdx.con == YES && *cpsx != ZERO)
	if(isspace(*cpsx))    ++cpsx;
	else
	if(*cpsx == ',')      {
		cdx.act += 1;
		cdx.nn2 = pcmd1(cpsx = cpsx + 1, cdx.cur);
		}
	else
	if(*cpsx == ';')      {
		cdx.act += 1;
		cdx.nn2 = pcmd1(cpsx = cpsx + 1, cdx.nn1);
		}
	else                break;
/**/
	if(cdx.con == YES)  return(doflags(cpsx));
	else                {
						cdx.cur = minof2(cdx.sve,cdx.lst);
						return(cdx.con = NO);
						}
}
pcmd1(is,dot)
int     dot;
char    *is;
{
	auto	int 	nr = pcmd2(cpsx = is, dot);
	while(cdx.con == YES && *cpsx != ZERO)
	if(isspace(*cpsx))    	++cpsx;
	else
	if(*cpsx == '+')      	nr += pcmd2(++cpsx , nr);
	else
	if(*cpsx == '-')      	nr -= pcmd2(++cpsx , nr);
	else                	break;
	if(cdx.con == YES)  	return(nr);
	else					return(cdx.con = NO);
}
pcmd2(is,dot)
int     dot;
char    *is;
{
	int     nr = 1;
/**/
	cpsx = is;
	while(cdx.con == YES && *cpsx != ZERO)
	if(isspace(*cpsx))    ++cpsx;
	else
	if(isdigit(*cpsx))    {
		nr = atoi(cpsx);
		while(isdigit(*cpsx)) ++cpsx;
		break;
		}
	else
	if(*cpsx == '$')  {
		cpsx += 1;
		nr = cdx.lst;
		break;
		}
	else
	if(*cpsx == '.')  {
		cpsx += 1;
		nr = cdx.cur;
		break;
		}
	else
	if(*cpsx == '-')  {
		nr = pcmd2(++cpsx,dot);
		nr = dot - nr;
		break;
		}
	else
	if(*cpsx == '+')  {
		nr = pcmd2(++cpsx,dot);
		nr = dot + nr;
		break;
		}
	else
	if(*cpsx == '\'')	{
		cpsx += 1;
		nr = gtmark(*cpsx++);
		break;
		}
	else
	if(*cpsx == '?')	{
		pullp(cpsx);
		nr = findp('?');
		break;
		}
	else
	if(*cpsx == '%')	{
		pullh(cpsx);
		nr = findh('%');
		break;
		}
	else
	if(*cpsx == '/')	{
		pullp(cpsx);
		nr = findp('/');
		break;
		}
	else                        		{
		nr = 1;
		break;
		}
	if(cdx.con != YES)	terror(FUBAR);
	return(nr);
}
pullp(is)		/* pull and compile pattern */
char    *is;
{
	static  	int 	pp = NO;
	auto		char    ws[FNMSIZ];
	extern		int	canescape;
	cpsx = is;
	if(is[1] == ZERO || is[0] == is[1]) {
		while(*cpsx == '/' || *cpsx == '?') ++cpsx;
		if(pp)      return(0);
		else    	{
			errmsg("pullp <no valid pattern>\n");
			terror(FUBAR);
			}
		}
	cpsx = xgnc(ws,ws+FNMSIZ-1,cpsx + 1, *cpsx);
	if(canescape)	xesc(ws);
	if(re_comp(ws))	{
			errmsg("pullp: <bad pattern> '%s'\n",ws);
			terror(FUBAR);
			}
	else 	pp = YES;
	return(0);
}
findp(ty)	/* find a regular expression */
int     ty;
{
	auto	int		cur = cdx.cur;
	auto	int		fnd = cdx.cur;
	auto	FUNCP	func;
/**/
	if(ty == '/')	func = (FUNCP) nextcd;
	else
	if(ty == '?')	func = (FUNCP) prevcd;
	else			dump("findp: ty");
/**/
	do  {
		fnd = (*func)(fnd);
		getcd(fnd,LINE_IO);
		if(re_exec(kb.base)) return(fnd);
	}
	while(fnd != cur) ;
/**/
	if(!cdx.glb && kenv.prompt)
		printff("<no match>\n");
/**/
	return(cdx.con = NO);
}
