/*DOSLIB*/
/*UNXLIB*/
/*
**	map kroff over struck vowels into IBM extended
**	ascii codes for printing on the HP Think-JET
*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
#include	<signal.h>
/**/
/*EXTERN*/
extern	int		maptext();
extern	int		hp();
/**/
long	fsize;
long	begtm;
long	cleft;
long	csent;
long	curtm;
int	rl;
int	nd;
int	pc;
int	rt;
/**/
char	*initr = "\033\100";
#define	XPAND	1
char	*xpand	=	"\016";
#define	COMPR	2
char	*compr	=	"\017";
#define	BOLDF	4
char	*boldf	=	"\033\005";
char	*romaf	=	"\033\006";
#define	UNDER	8
char	*under	=	"\033-1";
#define	FORMF	16
char	*formf	=	"\014";
#define	UNIDP	32
char	*unidp	=	"\033U1";
#define	LINE6	1
char	*line6	=	"\0332";
#define	LINE7	2
char	*line7	=	"\0331";
#define	LINE8	4
char	*line8	=	"\0330";
/**/
/**/
KENV	kenv;
/**/
void
terror(ty)		/* write a formfeed and die */
int	ty;
{
	signal(SIGINT,SIG_IGN);
	fputs(formf,stdout);
	fflush(stdout);
	fclose(stdout);
	exit(ty);
}
/**/
main(argc,argv)
int	argc;
char	*argv[];
{
	kenv.dosdos = isdos();
	disnme(kenv.pname = "hp");
	exit(cmdxrc(argc,argv,hp,"hp.xrc"));
}
hp(argc,argv)
int	argc;
char	*argv[];
{
/**/
	auto	char	*ob = NULL;
/**/
	if(kenv.dosdos)	cmdxpd(argc,argv);
	else			telluser(kenv.pname);
/**/
	disrec(cmdnum(argc,argv,'R',1,0));
/**/
	if(cmdnum(argc,argv,'h',0,1))	hint(0);
/**/
	if(cmdnum(argc,argv,'t',0,1))	;
	else	{
		if(kenv.dosdos)	freopen("/dev/prn","w",stdout);
		else		freopen("/dev/lp","w",stdout);
		}
/**/
#ifdef	SYSV
	kenv.blockd = cmdnum(argc,argv,'B',16,16) * bufsiz();
	ob = ksetvbuf(stdout,ob,_IOFBF,kenv.blockd);
#endif	/*SYSV*/
/**/
	setcbrk(YES);
	signal(SIGINT,terror);
/**/
	kenv.flags0 = cmdnum(argc,argv,'T',1,0);
	kenv.flags1 |= cmdnum(argc,argv,'x',kenv.flags1,XPAND);
	kenv.flags1 |= cmdnum(argc,argv,'c',kenv.flags1,COMPR);
	kenv.flags1 |= cmdnum(argc,argv,'b',kenv.flags1,BOLDF);
	kenv.flags1 |= cmdnum(argc,argv,'f',kenv.flags1,FORMF);
	kenv.flags1 |= cmdnum(argc,argv,'f',kenv.flags1,UNIDP);
	switch(kenv.flags2 = cmdnum(argc,argv,'v',LINE6,LINE8))	{
		default:
		case	LINE6:	rl = 66;break;
		case	LINE7:	rl = 77;break;
		case	LINE8:	rl = 88;break;
		}
	kenv.flags3 = cmdnum(argc,argv,'s',0,66);
	kenv.flags4 = cmdnum(argc,argv,'q',0,66);
	kenv.report = cmdnum(argc,argv,'o',0,8);
	dolist(argc,argv,maptext);
	if(kenv.flags1 & FORMF)	fputs(formf,stdout);
	exit(0);
}
hint(ty)
{
static	char	*hx[] = {
"=hp [-options] file(s)",
"        this program is a printing utility for driving a",
"        Think-Jet printer (IBM mode) under XENIX/MSDOS.",
"        It expects plain ascii input or text produced with",
"        the '-T hp' option of kroff.",
"=",
"~",
"=OPTIONS",
"-T      provide timing estimates [on]",
"        not accurate until several full pages have been",
"        printed.",
"-b      bold",
"-c      compressed",
"-f      form feed after print",
"-h      hint",
"-qNN    quit after NN lines",
"-oNN    offset NN spaces",
"-sNN    start after NN lines",
"-t      terminal output",
"*       MSDOS default = '/dev/lpn'",
"*       UNIX default = '/dev/lp'",
"-u      unidirectional printing [off]",
"-v1     6 lines/inch [on]",
"-v2     7 lines/inch",
"-v4     8 lines/inch",
"-x      expanded",
"=",
"~",
"=BUGS",
"       the MSDOS version does NOT operate in background",
"=",
"~",
}	;
	prhint(hx,sizeof(hx)/sizeof(char**),NULL,ZERO);
	exit(ty);
}
maptext(fp)
FILE	*fp;
{
	auto		int	bold = NO;
	auto		char	ls[BUFSIZ];
	REG			char	*lsx;
	auto		int	lc = 0;
	auto		int	ox = 0;
	auto		int	ln = 0;
	if((cleft = fsize = filesize(getcfn())) <= 0L)	{
		kenv.flags0 = 0;
		}
	time(&begtm);
	fputs(initr,stdout);
	if(kenv.flags1 & XPAND)	fputs(xpand,stdout);
	if(kenv.flags1 & COMPR)	fputs(compr,stdout);
	if(kenv.flags1 & BOLDF)	fputs(boldf,stdout);
	if(kenv.flags1 & UNDER)	fputs(under,stdout);
	if(kenv.flags1 & UNIDP)	fputs(unidp,stdout);
	if(kenv.flags2 & LINE6)	fputs(line6,stdout);
	if(kenv.flags2 & LINE7)	fputs(line7,stdout);
	if(kenv.flags2 & LINE8)	fputs(line8,stdout);
	while(fgets(lsx = ls,BUFSIZ-1,fp))	{
		lc += 1;
		if(kenv.flags3 && lc <= kenv.flags3)	continue;
		if(kenv.flags4 && lc >= kenv.flags4)	break;
		if(kenv.report)	{
			for(ox = 0; ox < kenv.report; ox++)	putc(' ',stdout);
			}
		while(*lsx != ZERO)	{
			if(*lsx == '_' && lsx[1] == '\b')	{
				if(!bold)	{
					fputs(boldf,stdout);
					bold = YES;
					}
				lsx += 2;
				if(*lsx != ZERO)	putc(*lsx++,stdout);
				}
			else
			if(*lsx == '-' && lsx[1] == '\b')	{
				switch(lsx[2])	{
					case	'u':	putc((char) 150,stdout);
									break;
					case	'o':	putc((char) 147,stdout);
									break;
					case	'i':	putc((char) 140,stdout);
									break;
					case	'e':	putc((char) 136,stdout);
									break;
					case	'a':	putc((char) 131,stdout);
									break;
					default:		break;
					}
				lsx += 3;
				}
			else	{
				if(bold)	{
					fputs(romaf,stdout);
					bold = NO;
					}
				putc(*lsx++,stdout);
				}
			}
		if(kenv.flags0)	{
			ln = strlen(ls);
			csent += ln;
			cleft -= ln;
			if( (lc % rl) == 0)	{
				curtm = time(NULL) - begtm;
				curtm = curtm ? curtm : 1;
				rt = csent / curtm;
				rt = rt ? rt : 1;
				nd = (cleft / rt);
				pc = (cleft * 100L) / fsize;
				print("et %4ld ct %6ld rt %4d nd %4d pc %4d\n",
					curtm,csent,rt,nd,pc);
				}
			}
		}
	return(0);
}
